% Exemplary Solution for Exercise 1 - Assignment 3
% SNM HS2023, Jiwoo Oh, jiwoo.oh@chem.ethz.ch

% Clean up
clear all; close all;

%% Assignment 3 : Numerical Differentiation

% Definitions
x0 = 1;
f = @(x)log(x);
df_analytical = 1; % the analytical solution at x = 1
h = logspace(-15,-1,200);


% Q3.2 Forward finite differences
tic;
err_ffd  = zeros(length(h),1); % Array for error of FD with varying h; Preallocate zeros for speed
for i = 1:length(h)
    err_ffd(i) = abs((f(x0+h(i)) - f(x0))/h(i)-df_analytical)/df_analytical;
end
toc

% Alternative without loop
tic;
u_forward = (f(x0 + h) - f(x0)) ./ h; % element-by-element operation
err_ffd = abs((u_forward - df_analytical) / df_analytical);
toc



% Q3.4 Centered finite differences
tic;
err_cfd = err_ffd; % Preallocate for speed
for i = 2:length(h)
    err_cfd(i) = abs((f(x0+h(i)) - f(x0-h(i)))/(2*h(i))-df_analytical)/df_analytical;
end
toc;

% Alternative without loop
tic;
u_centered = (f(x0 + h) - f(x0 - h)) ./ (2*h);
err_cfd = abs(( u_centered - df_analytical) / df_analytical);
toc

% Q3.3 Plotting
figure
loglog(h,err_ffd,'rx') % forward finite difference h vs. error
hold on
loglog(h,err_cfd,'ko') % centered finite difference h vs. error
legend('Forward difference', 'Centered difference', 'Location', 'SouthWest')
xlabel('Stepsize h', 'FontSize', 16)
ylabel('Rel. error', 'FontSize', 16)
% At very low values of h, the error increases because the result (= 1) is
% calculated as for example 1.0000000000001/1e-12 - 1.000000000000/1e-12,
% therefore the computer precision is not enough to catch the important
% parts of the number where the calculations happen (round up error).

% The centered finite differences method is more accurate for large values
% of h. The value of h to reach optimal precision varies for the two
% methods.